=== debian/changelog ===
vulkan-loader (1.2.131.2-1~mx19+1) mx; urgency=medium

  * Repackage of upstream release for MX 19.

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Fri, 28 Feb 2020 10:27:38 -0500

vulkan-loader (1.2.131.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump debhelper to 12, use -compat.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 Feb 2020 17:17:52 +0200

vulkan-loader (1.1.126.0-2) unstable; urgency=medium

  * install-generated-headers.diff: Dropped, they're actually shipped by
    validationlayers now.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Nov 2019 20:28:51 +0200

vulkan-loader (1.1.126.0-1) unstable; urgency=medium

  * New upstream release.
  * install-extra-headers.diff: Install vk_layer_dispatch_table.h
    again, and add other pre-generated headers. (LP: #1849260)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Nov 2019 15:17:20 +0200

vulkan-loader (1.1.121.0-2) unstable; urgency=medium

  * control: Make mesa-vulkan-drivers the preferred driver package to
    install via Recommends. (Closes: #940560)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 17 Sep 2019 15:18:53 +0300

vulkan-loader (1.1.121.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Add vulkan-icd to libvulkan1 Recommends. (Closes: #935871)

  [ Helmut Grohne ]
  * Support DEB_BUILD_OPTIONS=nocheck to drop googletest. (Closes:
    #928696)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 17 Sep 2019 10:35:32 +0300
