## vulkan-loader 1.2.135.0

=== debian/changelog ===
vulkan-loader (1.2.135.0-2~mx19ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19 AHS.

 -- ”SwampRabbit” <swamprabbit@mxlinux.org>  Mon, 22 Jun 2020 12:32:24 -0400

vulkan-loader (1.2.135.0-2) unstable; urgency=medium

  * symbols: Add a separate symbols file for x86, strip missing symbols
    from the rest.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 09 Apr 2020 19:13:42 +0300

vulkan-loader (1.2.135.0-1) unstable; urgency=medium

  * New upstream release. (LP: #1871754)
  * control: Bump policy to 4.5.0.
  * symbols: Updated.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 09 Apr 2020 07:39:59 +0300
