=== debian/tests/control ===
Tests: libvulkan-dev
Restrictions: allow-stderr, superficial
Depends:
 libvulkan-dev,
