=== debian/changelog ===
vulkan-loader (1.2.141.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 12 Jun 2020 07:20:34 +0300

vulkan-loader (1.2.135.0-3) unstable; urgency=medium

  [ Simon McVittie ]
  * Add missing autopkgtests dependencies (Closes: #958836)

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 04 May 2020 13:33:06 +0300
