## vulkan-loader 1.2.148.1

=== debian/changelog ===
vulkan-loader (1.2.148.1-1~mx19ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 17 Sep 2020 08:42:20 -0400

vulkan-loader (1.2.148.1-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 07 Sep 2020 14:57:51 +0300
