=== debian/changelog ===
vulkan-loader (1.2.162.0-1~mx19ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 25 Jan 2021 16:25:54 -0500

vulkan-loader (1.2.162.0-1~bpo10+1) buster-backports; urgency=medium

  * Non-maintainer upload.
  * Rebuild for buster-backports.

 -- Luca Boccassi <bluca@debian.org>  Sat, 09 Jan 2021 16:40:39 +0000

vulkan-loader (1.2.162.0-1) unstable; urgency=medium

  * New upstream release.
  * fix-pkgconfig.diff: Dropped, upstream.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 07 Jan 2021 09:34:46 +0200

vulkan-loader (1.2.154.1-1~bpo10+1) buster-backports; urgency=medium

  * Non-maintainer upload.
  * Rebuild for buster-backports.

 -- Luca Boccassi <bluca@debian.org>  Fri, 01 Jan 2021 13:48:45 +0000

vulkan-loader (1.2.154.1-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 09 Oct 2020 09:58:07 +0300
