=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: vulkan-loader
 Priority: optional
-Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
 XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
  googletest <!nocheck>,
@@ -11,7 +12,7 @@
  libxrandr-dev,
  pkg-config,
  python3,
-Standards-Version: 4.2.0
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Loader
 Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/vulkan-loader.git
