## vulkan-loader 1.2.182.0

=== debian/changelog ===
vulkan-loader (1.2.182.0-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Dylan Aïssi <daissi@debian.org>  Tue, 07 Sep 2021 13:29:39 +0200

vulkan-loader (1.2.182.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 01 Sep 2021 15:12:01 +0300

vulkan-loader (1.2.182.0-1) experimental; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 13 Aug 2021 08:58:06 +0300
