## vulkan-loader 1.2.189.0

=== debian/changelog ===
vulkan-loader (1.2.189.0-2~mx21ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 12 Sep 2021 23:44:07 -0400

vulkan-loader (1.2.189.0-2) unstable; urgency=medium

  * fix-ftbfs.diff: Fix a typo in a test.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 07 Sep 2021 15:32:49 +0300

vulkan-loader (1.2.189.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 07 Sep 2021 13:40:34 +0300
